#include <ctype.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <signal.h>   //for sigaction

int one[2];
int two[2];

int tag1, tag2;

gint get_from_pipe(char* nope, int fd, GdkInputCondition cond)
{
	int res;
	char c;

	res = read(fd, &c, 1);
	
        printf("got data from fd %d, \"%c\", result %d\n", fd, c, res);
}

int main(int argc, char* argv[])
{

  gtk_init(&argc, &argv);

    {
      struct sigaction sig;
      sig.sa_flags = SA_NOCLDWAIT;
      sigaction(SIGCHLD, &sig, NULL);
    }


/* First one! */

  if (pipe(one) == -1)
    {
      perror("pipe"); 
      exit(1);
    }


  if (fork() == 0)
    {
      /* We're going to be the exernal program! */

      close(one[0]);    /* close read end of pipe */
      close(2);         /* close stderr. I'm not interested.  */
      dup2(one[1],1);   /* make 1 same as write-to end of pipe */
      close(one[1]);    /* close excess fildes */
      execlp("./one","./one", NULL);
      perror("exec");   /* still around?  exec failed           */
      _exit(1);         /* no flush                             */ 
    }

tag1 = gdk_input_add(one[0], GDK_INPUT_READ,
                    (GdkInputFunction)get_from_pipe, NULL);



/* Do number two. */

  if (pipe(two) == -1)
    {
      perror("pipe");
      exit(1);
    } 

      
  if (fork() == 0)
    {
      /* We're going to be the exernal program! */

      close(two[0]);    /* close read end of pipe */
      close(2);         /* close stderr. I'm not interested.  */
      dup2(two[1],1);   /* make 1 same as write-to end of pipe */
      close(two[1]);    /* close excess fildes */
      execlp("./two","./two", NULL);
      perror("exec");   /* still around?  exec failed           */
      _exit(1);         /* no flush                             */
    }



  tag2 = gdk_input_add(two[0], GDK_INPUT_READ,
                       (GdkInputFunction)get_from_pipe, NULL);


  gtk_main();
}
